<?php
/*
	Plugin Name: Z-Payment Gateway for WP e-Commerce
	Plugin URI: http://z-payment.com/docs.php
	Author: z-payment.com
	Author URI: http://z-payment.com
*/

			$nzshpcrt_gateways[$num]['name'] = 'Z-Payment';
			$nzshpcrt_gateways[$num]['internalname'] = 'Z-Payment';
            $nzshpcrt_gateways[$num]['image'] = 'http://z-payment.com/images/logo.gif';
			$nzshpcrt_gateways[$num]['function'] = 'wpplugin_wpec_zpayment_gateway';
			$nzshpcrt_gateways[$num]['form'] = 'wpplugin_wpec_zpayment_form';
			$nzshpcrt_gateways[$num]['submit_function'] = 'wpplugin_wpec_zpayment_submit';
			$nzshpcrt_gateways[$num]['payment_type'] = "zpayment";
            $nzshpcrt_gateways[$num]['display_name'] = __( 'Z-Payment', 'wpsc' );
			
			
			
			
	//оформление комментариев в форме настроек платежного шлюза
    function wpplugin_wpec_zpayment_form_hint($s)
	{
		return '<small style="line-height:14px;display:block;padding:2px 0 6px;">' . $s . '</small>';
	}

	// Форма настроек платежного шлюза
	function wpplugin_wpec_zpayment_form()
	{
		// Get stored values.
		$shop_id = get_option('zpayment_shop_id');
		$merchant_key = get_option('zpayment_merchant_key');
		$init_pass = get_option('zpayment_init_pass');
		$result_method   = get_option('zpayment_result_method');
      	$language=strtolower(substr(get_locale(), 0, 2));
		$failurl = get_option('shopping_cart_url');
        $successurl = get_option('transact_url');
		$callbackurl = get_option('siteurl')."/?zpayment_result=1";
						
		// Generate output.
		$output = '<tr><td colspan="2" style="text-align:center;"><br/><a href="http://z-payment.com/" target="_new"><img src="http://z-payment.com/images/logo.gif"/></a></td></tr>';
        if ($language == 'ru') $output .= '<tr><td colspan="2"><strong>Настройки платёжного шлюза</strong></td></tr>';
        else $output .= '<tr><td colspan="2"><strong>Merchant configuration</strong></td></tr>';

		// Shop ID.
		if ($language == 'ru') $output .= '<tr><td><label for="zpayment_shop_id">Идентификатор магазина:</label></td>';
		else $output .= '<tr><td><label for="zpayment_shop_id">Shop ID:</label></td>';
		$output .= '<td><input name="zpayment_shop_id" id="zpayment_shop_id" type="text" value="' . $shop_id . '"/><br/>';
		if ($language == 'ru') $output .= wpplugin_wpec_zpayment_form_hint('ID указан в меню `Магазины` в личном кабинете на сайте z-payment.com');
		else $output .= wpplugin_wpec_zpayment_form_hint('ID is specified in the z-payment.com private section');
		$output .= '</td></tr>';

		// Merchant Key.
		if ($language == 'ru') $output .= '<tr><td><label for="zpayment_merchant_key">Merchant Key:</label></td>';
		else $output .= '<tr><td><label for="zpayment_merchant_key">Merchant Key:</label></td>';
		$output .= '<td><input name="zpayment_merchant_key" id="zpayment_merchant_key" type="text" value="' . $merchant_key . '"/><br/>';
		if ($language == 'ru') $output .= wpplugin_wpec_zpayment_form_hint('Merchant Key указан в меню `Магазины` в личном кабинете на сайте z-payment.com (вкладка уведомления)');
		else $output .= wpplugin_wpec_zpayment_form_hint('Merchant Key is specified in the z-payment.com private section');
		$output .= '</td></tr>';
		
		//Initialization Password.
		if ($language == 'ru') $output .= '<tr><td><label for="zpayment_init_pass">Пароль инициализации:</label></td>';
		else $output .= '<tr><td><label for="zpayment_init_pass">Initialization Password:</label></td>';
		$output .= '<td><input name="zpayment_init_pass" id="zpayment_init_pass" type="text" value="' . $init_pass . '"/><br/>';
		if ($language == 'ru') $output .= wpplugin_wpec_zpayment_form_hint('Пароль инициализации указан в меню `Магазины` в личном кабинете на сайте z-payment.com (вкладка уведомления)');
		else $output .= wpplugin_wpec_zpayment_form_hint('Initialization Password is specified in the z-payment.com private section');
		$output .= '</td></tr>';

        //Result Method
        if ($language == 'ru') $output .= '<tr><td><label for="zpayment_result_method">Метод получения данных на Result URL:</label></td>';
		else $output .= '<tr><td><label for="zpayment_merchant_key">Method:</label></td>';
		$output .= '<td><select name="zpayment_result_method" id="zpayment_result_method">';
			$output .= '<option value="0"'.($result_method == '0' ? ' selected="selected"' : '').'>POST</option>';
			$output .= '<option value="1"'.($result_method == '1' ? ' selected="selected"' : '').'>GET</option>';
		$output .= '</select></td></tr>';

		
		// Result URL
		$output .= '<tr><td>Result URL:</td>';
		$output .= '<td>'.$callbackurl .'</td></tr>';
		// Success URL
		$output .= '<tr><td>Success URL:</td>';
		$output .= '<td>'.$successurl.'</td></tr>';
		// Fail URL
		$output .= '<tr><td>Fail URL:</td>';
		$output .= '<td>'.$failurl.'</td></tr>';
		
		
		return $output;
	}

	// Сохраняет данные формы Настроек платежного шлюза
	function wpplugin_wpec_zpayment_submit()
	{
		if($_POST['zpayment_shop_id'] != null)
			update_option('zpayment_shop_id', $_POST['zpayment_shop_id']);

		if($_POST['zpayment_merchant_key'] != null)
			update_option('zpayment_merchant_key', $_POST['zpayment_merchant_key']);

		if($_POST['zpayment_init_pass'] != null)
			update_option('zpayment_init_pass', $_POST['zpayment_init_pass']);	
			
        if($_POST['zpayment_result_method'] != null)
    		update_option('zpayment_result_method', $_POST['zpayment_result_method']);

        return true;
	}

	
	
	//формирование формы для отправки заказа 
	function wpplugin_wpec_zpayment_gateway($seperator, $session_id)
	{
		global $wpdb, $wpsc_cart;
        $shop_id = get_option('zpayment_shop_id');
		$amount	= round($wpsc_cart->total_price, 2);
        $email= $_POST['collected_data']['9'];
        $language=strtolower(substr(get_locale(), 0, 2));

	    $order_id = $wpdb->get_var("SELECT id FROM " . WPSC_TABLE_PURCHASE_LOGS . " WHERE sessionid = '$session_id' LIMIT 1;");
        $currency_code = $wpdb->get_var( $wpdb->prepare( "SELECT `code` FROM `".WPSC_TABLE_CURRENCY_LIST."` WHERE `id` = %d  LIMIT 1", get_option( 'currency_type' ) ) );

		if ($currency_code=="RUB")
        	$currency="rur";
        else
        	$currency=strtolower($currency_code);

		$wpdb->query("UPDATE " . WPSC_TABLE_PURCHASE_LOGS . " SET processed = '1', date = '" . time() . "' WHERE sessionid = " . $session_id . " LIMIT 1");


        $amount=number_format($amount, 2, '.', ''); 
		
		$init_pass = get_option('zpayment_init_pass');
	
		// Generate the form output.
		$output = "<div style=\"display:none;\">
		<form id=\"zpayment_form\" name=\"zpayment_form\" action=\"https://z-payment.com/merchant.php\" method=\"get\">
        <input type=\"hidden\" name=\"LMI_PAYEE_PURSE\" value=\"$shop_id\"/>
	    <input type=\"hidden\" name=\"LMI_PAYMENT_NO\" value=\"$order_id\"/>
		<input type=\"hidden\" name=\"LMI_PAYMENT_AMOUNT\" value=\"$amount\"/>
        <input type=\"hidden\" name=\"LMI_PAYMENT_DESC\" value=\"online_shop_payment\"/>
		<input type=\"hidden\" name=\"SESSION_ID\" value=\"$session_id\"/>
		";

				
		$zp_sign=md5($shop_id.$order_id.$amount.$init_pass); 
		$output .= "<input type=\"hidden\" name=\"ZP_SIGN\" value=\"$zp_sign\"/>";
		
		
		
		
        if ($language == 'ru') {
			$output.="<input type=\"hidden\" name=\"zpPurpose\" value=\"Заказ №".$order_id."\"/>
					  <input type=\"submit\" value=\"Оплатить\"/>";
		}
		else{
			$output.="<input type=\"hidden\" name=\"zpPurpose\" value=\"Order id: $sessionid\"/>
					  <input type=\"submit\" value=\"Pay\"/>";
		}

		$output.="</form>
		</div>";

		echo $output;
		echo "<script language=\"javascript\" type=\"text/javascript\">document.getElementById('zpayment_form').submit();</script>";
		exit();
	}
	
	function zpayment_callback()
		{								 
			global $wpdb; 
		
			$language=strtolower(substr(get_locale(), 0, 2));
   		   	$is_callback = false;

			if((isset($_GET['zpayment_result']) && $_GET['zpayment_result'] == '1'))
				$is_callback = true;

			// Process the callback.
			if($is_callback == true)
			{
						$method_num = get_option('zpayment_result_method');
                        if($method_num==0) {$method='POST';} else {$method='GET';} 
                        if($method=='POST') $HTTP = $_POST; 
                        else $HTTP = $_GET;
                        foreach ($HTTP as $Key=>$Value) { $$Key = $Value; }
						
					    $sessionid = trim(stripslashes($SESSION_ID));
						$shop_id = get_option('zpayment_shop_id');
                        $merch_key=get_option('zpayment_merchant_key');
                        $order = $LMI_PAYMENT_NO;
						$err = FALSE;
						 
						    if($LMI_PREREQUEST==1) {
	                        echo 'YES';
                            } else
							{
							    if(isset($LMI_SECRET_KEY)) {
                                    if($LMI_SECRET_KEY!=$merch_key) {
                                    $err = TRUE;
                                    $notes = 'Declined. Invalid Merchant key';
									}
								} else {
                                $CalcHash = md5($LMI_PAYEE_PURSE.$LMI_PAYMENT_AMOUNT.$LMI_PAYMENT_NO.$LMI_MODE.$LMI_SYS_INVS_NO.$LMI_SYS_TRANS_NO.$LMI_SYS_TRANS_DATE.$merch_key.$LMI_PAYER_PURSE.$LMI_PAYER_WM);
		                             if($LMI_HASH != strtoupper($CalcHash)) 
									{
                                     $err = TRUE;
	                                 $notes = 'Declined. Invalid hash';		
		                            }
                                }
							}
						
						 
							 if (!$err) 
							 {

							 $data = array(
						     'processed'  => 2,
						     'transactid' =>  $order,
						     'date'       => time(),
						     );
					         wpsc_update_purchase_log_details( $sessionid, $data, 'sessionid' );
					         transaction_results($sessionid, false, $order);
							 }
							 else 
							 {
							 $wpdb->query("UPDATE " . WPSC_TABLE_PURCHASE_LOGS . " SET  date = '" . time() . "', notes = '" . $notes . "' WHERE sessionid = " . $sessionid . " LIMIT 1");
							 }
							 
				exit();
			}
		}
	
	
	
	
	
	
	
// Function used to translate returned sessionid POST variable into the recognised GET variable for the transaction results page.
function zpayment_results()
{
	if(isset($_POST['SESSION_ID'])) {
		$_GET['sessionid'] = $_POST['SESSION_ID'];
	}
}


add_action('init', 'zpayment_callback');
add_action('init', 'zpayment_results');